{- ESF main program
    ghc --make Main.hs esf.c
-}

{-# LANGUAGE ForeignFunctionInterface #-}

module Main where
import Foreign.C.Types

main =
  do putStrLn "ESFA main program"
     putStrLn ("esf_init " ++ show (esf_init 0))
     putStrLn ("esf_dump " ++ show (esf_dump 0))
     let a1 = esf_update 0 1 10
     putStrLn ("a1 = " ++ show a1);
     let a2 = esf_update a1 2 20
     putStrLn ("a2 = " ++ show a2);
     let a3 = esf_update a2 3 30
     putStrLn ("a3 = " ++ show a3);

     putStrLn ("a3 " ++ show (esf_lookup a3 1)
                 ++ "  " ++ show (esf_lookup a3 2)
                 ++ "  " ++ show (esf_lookup a3 3))
  

     putStrLn ("esf_dump " ++ show (esf_dump 0))
     putStrLn "Main program terminating"

{-
     putStrLn (show (esf_update 1 2 3))
     putStrLn (show (esf_update 1 2 100))
     putStrLn (show (esf_update 1 2 42))
     putStrLn (show
               (esf_update 1 2 30 + esf_update 1 2 40 + esf_update 1 2 50))
-}

foreign import ccall safe "prototypes.h"
    esf_update :: CInt -> CInt -> CInt -> CInt
foreign import ccall safe "prototypes.h"
    esf_lookup :: CInt -> CInt -> CInt
foreign import ccall safe "prototypes.h"
    esf_init :: CInt -> CInt
foreign import ccall safe "prototypes.h"
    esf_dump :: CInt -> CInt
